[parted-devel] [PATCH 2/2] tests: add test for new mkpart functionality with IEC units

Petr Uzel petr.uzel at suse.cz
Sat Oct 22 13:22:10 UTC 2011


* tests/t0208-mkpart-end-in-IEC.sh: New test.
* tests/t0207-IEC-binary-notation.sh: Adjust to match new functionality.
* tests/Makefile.am: Call the test.
---
 tests/Makefile.am                  |    1 +
 tests/t0207-IEC-binary-notation.sh |    2 +-
 tests/t0208-mkpart-end-in-IEC.sh   |   65 ++++++++++++++++++++++++++++++++++++
 3 files changed, 67 insertions(+), 1 deletions(-)
 create mode 100644 tests/t0208-mkpart-end-in-IEC.sh

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 5a8a539..63bcd31 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -18,6 +18,7 @@ TESTS = \
   t0205-gpt-list-clobbers-pmbr.sh \
   t0206-gpt-print-with-corrupt-primary-clobbers-pmbr.sh \
   t0207-IEC-binary-notation.sh \
+  t0208-mkpart-end-in-IEC.sh \
   t0220-gpt-msftres.sh \
   t0250-gpt.sh \
   t0280-gpt-corrupt.sh \
diff --git a/tests/t0207-IEC-binary-notation.sh b/tests/t0207-IEC-binary-notation.sh
index 2228ce1..343b8c1 100644
--- a/tests/t0207-IEC-binary-notation.sh
+++ b/tests/t0207-IEC-binary-notation.sh
@@ -23,7 +23,7 @@ n_sectors=3000
 dev=dev-file
 
 dd if=/dev/null of=$dev bs=$ss seek=$n_sectors || fail=1
-parted --align=none -s $dev mklabel gpt mkpart p1 $((64*1024))B $((1024*1024))B \
+parted --align=none -s $dev mklabel gpt mkpart p1 $((64*1024))B $((1024*1024-$ss))B \
     > err 2>&1 || fail=1
 compare err /dev/null || fail=1
 parted -m -s $dev u s p > exp || fail=1
diff --git a/tests/t0208-mkpart-end-in-IEC.sh b/tests/t0208-mkpart-end-in-IEC.sh
new file mode 100644
index 0000000..cbd378d
--- /dev/null
+++ b/tests/t0208-mkpart-end-in-IEC.sh
@@ -0,0 +1,65 @@
+#!/bin/sh
+# Make sure parted mkpart ends the partition one sector before the specified
+# value if end is specified with IEC units.
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../parted
+
+require_512_byte_sector_size_
+n_mbs=8
+dev=dev-file
+
+dd if=/dev/null of=$dev bs=1M seek=$n_mbs || fail=1
+# create 1st partition
+parted --align=none -s $dev mklabel gpt mkpart p1 1MiB 2MiB \
+    > err 2>&1 || fail=1
+
+# expect no output
+compare err /dev/null || fail=1
+#parted -m -s $dev u s p > exp || fail=1
+
+# create 2nd partition - they should not overlap
+# this time specify default unit
+parted --align=none -s $dev unit MiB mkpart p2 2 3 \
+    > err 2>&1 || fail=1
+
+# expect no output
+compare err /dev/null || fail=1
+
+# create 3rd partition - expect no overlap
+# specify default unit, but explicitly override it
+parted --align=none -s $dev unit TB mkpart p3 3MiB 4MiB \
+    > err 2>&1 || fail=1
+
+# expect no output
+compare err /dev/null || fail=1
+
+# check boundaries of the partitions
+parted -m -s $dev u s p > out || fail=1
+
+# prepare expected output
+cat <<EOF > exp || framework_failure
+1:2048s:4095s:2048s::p1:;
+2:4096s:6143s:2048s::p2:;
+3:6144s:8191s:2048s::p3:;
+EOF
+
+# compare expected and actual outputs
+sed -e "1,2d" out > k; mv k out
+compare out exp || fail=1
+
+Exit $fail
-- 
1.7.3.4




More information about the parted-devel mailing list